Index: sandbox/MultiChannelUSB/UserInterface.tcl
===================================================================
--- sandbox/MultiChannelUSB/UserInterface.tcl	(revision 106)
+++ sandbox/MultiChannelUSB/UserInterface.tcl	(revision 143)
@@ -1036,91 +1822,285 @@
         grid columnconfigure ${master} 1 -weight 0 -minsize 120
 
-        grid columnconfigure ${display} 0 -weight 1
-        grid rowconfigure ${display} 0 -weight 1
-        grid rowconfigure ${display} 1 -weight 1
-        grid rowconfigure ${display} 2 -weight 1
-        grid rowconfigure ${display} 3 -weight 1
+        grid columnconfigure ${config}.chan_frame 2 -weight 1
 
         # enable zooming
-        Blt_ZoomStack $graph(0)
-        Blt_ZoomStack $graph(1)
-        Blt_ZoomStack $graph(2)
-        Blt_ZoomStack $graph(3)
-
-        #bind .graph <Motion> {%W crosshairs configure -position @%x,%y}
+        Blt_ZoomStack $graph
+
+        my crosshairs $graph
 
         # create one element with data for the x and y axis, no dots
-        $graph(0) element create Spectrum0 -symbol none -xdata $xvec -ydata $yvec(0)
-        $graph(1) element create Spectrum1 -symbol none -xdata $xvec -ydata $yvec(1)
-        $graph(2) element create Spectrum2 -symbol none -xdata $xvec -ydata $yvec(2)
-        for {set i 3} {$i < 11} {incr i} {
-          $graph(3) element create Spectrum$i -symbol none -xdata $xvec -ydata $yvec($i)
-        }
-    }
-
-# -------------------------------------------------------------------------
-
-    EptDisplay instproc recs_val_update args {
+        $graph pen create pen1 -color turquoise3 -linewidth 2 -symbol none
+        $graph pen create pen2 -color SpringGreen3 -linewidth 2 -symbol none
+        $graph pen create pen3 -color orchid3 -linewidth 2 -symbol none
+        $graph pen create pen4 -color orange3 -linewidth 2 -symbol none
+        $graph pen create pen5 -color blue2 -linewidth 2 -symbol none
+        $graph pen create pen6 -color gray55 -linewidth 2 -symbol none
+
+        $graph element create Spectrum1 -pen pen1 -xdata $xvec -ydata [dict get $yvec 1]
+        $graph element create Spectrum2 -pen pen2 -xdata $xvec -ydata [dict get $yvec 2]
+        $graph element create Spectrum3 -pen pen3 -xdata $xvec -ydata [dict get $yvec 3]
+        $graph element create Spectrum4 -pen pen4 -xdata $xvec -ydata [dict get $yvec 4]
+        $graph element create Spectrum5 -pen pen5 -xdata $xvec -ydata [dict get $yvec 5]
+        $graph element create Spectrum6 -pen pen6 -xdata $xvec -ydata [dict get $yvec 6]
+    }
+
+# -------------------------------------------------------------------------
+
+    OscDisplay instproc coor_update {W x y} {
+        my instvar xvec yvec graph
+        my instvar config
+
+        $W crosshairs configure -position @${x},${y}
+
+        set index [$W axis invtransform x $x]
+        set index [::tcl::mathfunc::round $index]
+        catch {
+            ${config}.chan_frame.chan1_value configure -text [[dict get $yvec 1] index $index]
+            ${config}.chan_frame.chan2_value configure -text [[dict get $yvec 2] index $index]
+            ${config}.chan_frame.chan3_value configure -text [[dict get $yvec 3] index $index]
+            ${config}.chan_frame.chan4_value configure -text [[dict get $yvec 4] index $index]
+            ${config}.chan_frame.chan5_value configure -text [[dict get $yvec 5] index $index]
+            ${config}.chan_frame.chan6_value configure -text [[dict get $yvec 6] index $index]
+            ${config}.chan_frame.axisx_value configure -text ${index}.0
+        }
+    }
+# -------------------------------------------------------------------------
+
+    OscDisplay instproc crosshairs {graph} {
+        set method [myproc coor_update]
+        bind $graph <Motion> [list [self] coor_update %W %x %y]
+        bind $graph <Leave> {
+            %W crosshairs off
+        }
+        bind $graph <Enter> {
+            %W crosshairs on
+        }
+    }
+
+# -------------------------------------------------------------------------
+
+    OscDisplay instproc chan_update {name key op} {
+        my instvar config graph chan
+
+        if {$chan(${key})} {
+            $graph pen configure pen${key} -linewidth 2
+        } else {
+            $graph pen configure pen${key} -linewidth 0
+        }
+    }
+
+# -------------------------------------------------------------------------
+
+    OscDisplay instproc recs_val_update args {
         my instvar recs_val
         if {[string equal $recs_val {}]} {
-            set number_val 0
-        }
-    }
-
-# -------------------------------------------------------------------------
-
-    EptDisplay instproc data_update args {
-        my instvar data xvec yvec graph last
+            set recs_val 0
+        }
+    }
+
+# -------------------------------------------------------------------------
+
+    OscDisplay instproc last_update args {
+        my instvar graph last
 
         set first [expr {$last - 1}]
+
+        $graph axis configure x -min ${first}0000 -max ${last}0000
+    }
+
+# -------------------------------------------------------------------------
+
+    OscDisplay instproc thrs_update {reset args} {
+        my instvar controller config thrs thrs_val
+
+        if {[string equal $thrs_val {}]} {
+            set thrs_val 0
+        }
+
+        if {$thrs} {
+            ${config}.thrs_field configure -state normal
+            set value [format %03x $thrs_val]
+        } else {
+            ${config}.thrs_field configure -state disabled
+            set value 000
+        }
+
+        set command {}
+        if {$reset} {
+            append command 0002000500041${value}
+        }
+        append command 0002000500040${value}
+
+        $controller usbCmd $command
+    }
+
+# -------------------------------------------------------------------------
+
+    OscDisplay instproc data_update args {
+        my instvar data yvec
+        my instvar graph chan waiting sequence auto
+
+        usb::convertOsc $data $yvec
+
+        foreach {key value} [array get chan] {
+            $graph pen configure pen${key} -dashes 0
+        }
+
+        set waiting 0
+
+        if {$sequence} {
+            my sequence_register
+        } elseif {$auto} {
+            after 1000 [myproc acquire_start]
+        }
+    }
+
+# -------------------------------------------------------------------------
+
+    OscDisplay instproc acquire_start {} {
+        my instvar graph chan controller waiting
+
+        foreach {key value} [array get chan] {
+            $graph pen configure pen${key} -dashes dot
+        }
+
+        # restart
+        my thrs_update 1
+
+        set waiting 1
+
+        after 200 [myproc acquire_loop]
+    }
+
+# -------------------------------------------------------------------------
+
+    OscDisplay instproc acquire_loop {} {
+        my instvar controller waiting
+
+#        set size 262144
+        set size 10000
+
+        set value [format {%08x} [expr {$size * 4}]]
+
+        set command 00011000000200000001[string range $value 0 3]0003[string range $value 4 7]00050000
         
-        $xvec seq ${first}0000 ${last}0000
-        for {set i 0} {$i < 4} {incr i} {
-            $graph($i) axis configure x -min ${first}0000 -max ${last}0000
-        }
-
-        for {set i 0} {$i < 11} {incr i} {
-            $yvec($i) set [lrange [lindex $data $i] ${first}0000 ${last}0000]
-        }
-    }
-
-
-# -------------------------------------------------------------------------
-
-    EptDisplay instproc save_data {data} {
-        set file [tk_getSaveFile]
-        if {[string equal $file {}]} {
+        $controller usbCmdReadRaw $command [expr {$size * 8}] [myvar data]
+
+        if {$waiting} {
+            after 200 [myproc acquire_loop]
+        }
+    }
+
+# -------------------------------------------------------------------------
+
+    OscDisplay instproc auto_update args {
+        my instvar config auto
+
+        if {$auto} {
+            ${config}.recs_field configure -state disabled
+            ${config}.sequence configure -state disabled
+            ${config}.acquire configure -state disabled
+            ${config}.register configure -state disabled
+            ${config}.recover configure -state disabled
+
+            my acquire_start
+        } else {
+            ${config}.recs_field configure -state normal
+            ${config}.sequence configure -state active
+            ${config}.acquire configure -state active
+            ${config}.register configure -state active
+            ${config}.recover configure -state active
+        }
+    }
+
+# -------------------------------------------------------------------------
+
+    OscDisplay instproc save_data {fname} {
+        my instvar data
+
+        set fid [open $fname w+]
+        fconfigure $fid -translation binary -encoding binary
+
+#        puts -nonewline $fid [binary format "H*iH*" "1f8b0800" [clock seconds] "0003"]
+#        puts -nonewline $fid [zlib deflate $data]
+        puts -nonewline $fid $data
+#        puts -nonewline $fid [binary format i [zlib crc32 $data]]
+#        puts -nonewline $fid [binary format i [string length $data]]
+
+        close $fid
+    }
+
+# -------------------------------------------------------------------------
+
+    OscDisplay instproc open_data {} {
+        set types {
+            {{Data Files}       {.dat}     }
+            {{All Files}        *             }
+        }
+
+        set fname [tk_getOpenFile -filetypes $types]
+        if {[string equal $fname {}]} {
             return
         }
 
-        set x [catch {set fid [open $file w+]}]
-        set y [catch {puts $fid $data}]
-        set z [catch {close $fid}]
-
-        if { $x || $y || $z || ![file exists $file] || ![file isfile $file] || ![file readable $file] } {
+        set x [catch {
+            set fid [open $fname r+]
+            fconfigure $fid -translation binary -encoding binary
+#            set size [file size $fname]
+#            seek $fid 10
+#            my set data [zlib inflate [read $fid [expr {$size - 18}]]]
+            my set data [read $fid]
+            close $fid
+        }]
+
+        if { $x || ![file exists $fname] || ![file isfile $fname] || ![file readable $fname] } {
             tk_messageBox -icon error \
-                -message "An error occurred while writing to \"$file\""
+                -message "An error occurred while reading \"$fname\""
         } else {
             tk_messageBox -icon info \
-                -message "File \"$file\" written successfully"
-        }
-    }
-
-# -------------------------------------------------------------------------
-
-    EptDisplay instproc acquire {} {
-        my usbCmdReadEpt 00060000 2097152
-   }
-
-# -------------------------------------------------------------------------
-
-    EptDisplay instproc register {} {
-        my save_data [my set data]
-    }
-
-# -------------------------------------------------------------------------
-
-    EptDisplay instproc sequence {} {
-        my instvar config recs_val directory counter
+                -message "File \"$fname\" read successfully"
+        }
+    }
+
+# -------------------------------------------------------------------------
+
+    OscDisplay instproc register {} {
+        set types {
+            {{Data Files}       {.dat}     }
+            {{All Files}        *             }
+        }
+
+        set stamp [clock format [clock seconds] -format %Y%m%d_%H%M%S]
+        set fname oscillogram_${stamp}.dat
+
+        set fname [tk_getSaveFile -filetypes $types -initialfile $fname]
+        if {[string equal $fname {}]} {
+            return
+        }
+    
+        if {[catch {my save_data $fname} result]} {
+            tk_messageBox -icon error \
+                -message "An error occurred while writing to \"$fname\""
+        } else {
+            tk_messageBox -icon info \
+                -message "File \"$fname\" written successfully"
+        }
+    }
+
+# -------------------------------------------------------------------------
+
+    OscDisplay instproc recover {} {
+        my open_data
+    }
+
+# -------------------------------------------------------------------------
+
+    OscDisplay instproc sequence_start {} {
+        my instvar config recs_val recs_bak directory counter sequence
+
+        set counter 1
+        if {$counter > $recs_val} {
+            return
+        }
 
         set directory [tk_chooseDirectory -initialdir $directory -title {Choose a directory}]
@@ -1131,258 +2111,90 @@
 
         ${config}.recs_field configure -state disabled
-        ${config}.sequence configure -state disabled
+        ${config}.sequence configure -text {Stop Recording} -command [myproc sequence_stop]
         ${config}.acquire configure -state disabled
         ${config}.register configure -state disabled
+        ${config}.recover configure -state disabled
         
-        set counter 1
+        set recs_bak $recs_val
+
+        set sequence 1
+
+        my acquire_start
+    }
+
+# -------------------------------------------------------------------------
+
+    OscDisplay instproc sequence_register {} {
+        my instvar config recs_val recs_bak directory counter
+
+        set fname [file join $directory oscillogram_$counter.dat]
+
+        my incr counter
+
+        if {[catch {my save_data $fname} result]} {
+            tk_messageBox -icon error \
+                -message "An error occurred while writing to \"$fname\""
+        } elseif {$counter <= $recs_bak} {
+            set recs_val [expr {$recs_bak - $counter}]
+            my acquire_start
+            return
+        }
         
-        if {$counter <= $recs_val} {
-            ${config}.stat configure -text "record $counter of $recs_val"
-            set after_handle [after 100 [myproc acquire_register_loop]]
-        }
-    }
-
-# -------------------------------------------------------------------------
-
-    EptDisplay instproc acquire_register_loop {} {
-        my instvar after_handle
-        my instvar config data recs_val directory counter
-
-        my acquire
-
-        set file [file join $directory ept_$counter.dat.gz]
-
-        set x [catch {set fid [open $file w+]}]
-        fconfigure $fid -translation binary -encoding binary
-
-        set y [catch {
-            puts -nonewline $fid [binary format "H*iH*" "1f8b0800" [clock seconds] "0003"]
-            puts -nonewline $fid [zlib deflate $data]
-            puts -nonewline $fid [binary format i [zlib crc32 $data]]
-            puts -nonewline $fid [binary format i [string length $data]]
-        }]
-
-        set z [catch {close $fid}]
-
-        my incr counter
-
-        if { $x || $y || $z || ![file exists $file] || ![file isfile $file] || ![file readable $file] } {
-            tk_messageBox -icon error -message "An error occurred while writing to \"$file\""
-        } elseif {$counter <= $recs_val} {
-            ${config}.stat configure -text "record $counter of $recs_val"
-            set after_handle [after 100 [myproc acquire_register_loop]]
-            return
-        }
+        my sequence_stop
+    }
+
+# -------------------------------------------------------------------------
+
+    OscDisplay instproc sequence_stop {} {
+        my instvar config recs_val recs_bak sequence
+
+        set sequence 0
         
-        ${config}.stat configure -text {}
+        set recs_val $recs_bak
+
         ${config}.recs_field configure -state normal
-        ${config}.sequence configure -state active
+        ${config}.sequence configure -text {Start Recording} -command [myproc sequence_start]
         ${config}.acquire configure -state active
         ${config}.register configure -state active
-
-    }
-
-# -------------------------------------------------------------------------
-
-    Class MemDisplay -superclass Display -parameter {
-        {number}
-        {master}
-    }
-
-# -------------------------------------------------------------------------
-
-    MemDisplay instproc init {} {
-        my instvar data xvec yvec
-
-        set xvec [vector #auto]
-        set yvec [vector #auto]
-
-        # fill one vector for the x axis
-        $xvec seq 0 10000
-
-        my reset
-
-        my setup
-
-        next
-    }
-
-# -------------------------------------------------------------------------
-
-    MemDisplay instproc destroy {} {
-        next
-    }
-
-# -------------------------------------------------------------------------
-
-    MemDisplay instproc reset {} {
-        my instvar data xvec yvec
-
-        set data {}
-
-        $yvec set {}
-    }
-
-# -------------------------------------------------------------------------
-
-    MemDisplay instproc start {} {
-        my instvar config
-
-        trace add variable [myvar data] write [myproc data_update]
-        trace add variable [myvar last] write [myproc data_update]
-    }
-
-# -------------------------------------------------------------------------
-
-    MemDisplay instproc setup {} {
-        my instvar master
-        my instvar data xvec yvec
-        my instvar config auto thrs thrs_val disp_val trig_val
-
-        # create a graph widget and show a grid
-        set graph [graph ${master}.graph -height 250 -leftmargin 80]
-        $graph crosshairs configure -hide no -linewidth 2 -dashes { 1 1 }
-        $graph grid configure -hide no
-        $graph legend configure -hide yes
-        $graph axis configure x -min 0 -max 10000
-#        $graph axis configure y -min 0 -max 4100
-
-        scale ${master}.last -orient horizontal -from 1 -to 105 -tickinterval 0 -variable [myvar last]
-
-        set config [frame ${master}.config]
-
-        button ${config}.acquire -text Acquire \
-            -bg green -activebackground green -command [myproc acquire]
-        button ${config}.register -text Register \
-            -bg lightblue -activebackground lightblue -command [myproc register]
-
-        grid ${config}.acquire -sticky ew -pady 3 -padx 5
-        grid ${config}.register -sticky ew -pady 3 -padx 5
-
-        grid ${graph} -row 0 -column 0 -sticky news
-        grid ${config} -row 0 -column 1
-
-        grid ${master}.last -row 1 -column 0 -columnspan 2 -sticky ew
-
-        grid rowconfigure ${master} 0 -weight 1
-        grid columnconfigure ${master} 0 -weight 1
-        grid columnconfigure ${master} 1 -weight 0 -minsize 80
-
-        # enable zooming
-        Blt_ZoomStack $graph
-
-        #bind .graph <Motion> {%W crosshairs configure -position @%x,%y}
-
-        # create one element with data for the x and y axis, no dots
-        $graph element create Spectrum -symbol none -xdata $xvec -ydata $yvec
-    }
-
-# -------------------------------------------------------------------------
-
-    MemDisplay instproc data_update args {
-        my instvar data yvec last
-
-        set first [expr {$last - 1}]
-        $yvec set [lrange $data ${first}0000 ${last}0000]
-    }
-
-# -------------------------------------------------------------------------
-
-    MemDisplay instproc save_data {data} {
-        set file [tk_getSaveFile]
-        if {[string equal $file {}]} {
-            return
-        }
-
-        set x [catch {set fid [open $file w+]}]
-        set y [catch {puts $fid $data}]
-        set z [catch {close $fid}]
-
-        if { $x || $y || $z || ![file exists $file] || ![file isfile $file] || ![file readable $file] } {
-            tk_messageBox -icon error \
-                -message "An error occurred while writing to \"$file\""
-        } else {
-            tk_messageBox -icon info \
-                -message "File \"$file\" written successfully"
-        }
-    }
-
-# -------------------------------------------------------------------------
-
-    MemDisplay instproc acquire {} {
-        my usbCmdRead 00040000 1 524288
-#        my usbCmdRead 00060000 1 1048576
-   }
-
-# -------------------------------------------------------------------------
-
-    MemDisplay instproc register {} {
-        my save_data [my set data]
-    }
-
-# -------------------------------------------------------------------------
-
-    namespace export MemDisplay
-    namespace export EptDisplay
+        ${config}.recover configure -state active
+    }
+
+# -------------------------------------------------------------------------
+
+    namespace export MuxDisplay
     namespace export HstDisplay
+    namespace export CntDisplay
     namespace export OscDisplay
-    namespace export CfgDisplay
 }
 
-set config [frame .config]
 set notebook [::blt::tabnotebook .notebook -borderwidth 1 -selectforeground black -side bottom]
 
-grid ${config} -row 0 -column 0 -sticky ns -padx 3
-grid ${notebook} -row 0 -column 1  -sticky news -pady 5
+grid ${notebook} -row 0 -column 0  -sticky news -pady 5
 
 grid rowconfigure . 0 -weight 1
-grid columnconfigure . 0 -weight 0  -minsize 50
-grid columnconfigure . 1 -weight 1
-
-foreach i {0 1 2} {
-    set channel [expr $i + 1]
-
-    set window [frame ${notebook}.hst_$i]
-    $notebook insert end -text "Histogram $channel" -window $window -fill both
-    ::mca::HstDisplay hst_$i -number $i -master $window
-
-    set window [frame ${notebook}.osc_$i]
-    $notebook insert end -text "Pulse shape $channel" -window $window -fill both
-    ::mca::OscDisplay osc_$i -number $i -master $window
-}
-
-#set window [frame ${notebook}.cfg]
-#$notebook insert end -text "Configuration" -window $window -fill both
-::mca::CfgDisplay cfg -master $config
+grid columnconfigure . 0 -weight 1
+
+::mca::UsbController usb
+usb usbCmd 00000000
+
+set window [frame ${notebook}.spi]
+$notebook insert end -text "DAC & ADC control" -window $window -fill both
+::mca::SpiDisplay spi -master $window -controller usb
+
+set window [frame ${notebook}.mux]
+$notebook insert end -text "Interconnect" -window $window -fill both
+::mca::MuxDisplay mux -master $window -controller usb
 
 set window [frame ${notebook}.ept]
-$notebook insert end -text "EPT" -window $window -fill both
-::mca::EptDisplay ept -master $window
-
-#set window [frame ${notebook}.mem]
-#$notebook insert end -text "Memory test" -window $window -fill both
-#::mca::MemDisplay mem -master $window
-
-set usb_handle {}
-
-while {[catch {usb::connect 0x09FB 0x6001 1 1 0} usb_handle]} {
-    set answer [tk_messageBox -icon error -type retrycancel \
-        -message {Cannot access USB device} -detail $usb_handle]
-    if {[string equal $answer cancel]} break
-}
-
-# cfg reset
-cfg reset
-
-cfg start
-
-foreach i {0 1 2} {
-    hst_$i start
-    osc_$i start
-
-    hst_$i restart
-    osc_$i restart
-}
-
-ept start
-#mem start
+$notebook insert end -text "Oscilloscope" -window $window -fill both
+::mca::OscDisplay osc -master $window -controller usb
+
+update
+
+spi start
+
+mux start
+
+osc start
+
+spi adc_reset
